import svelte from 'rollup-plugin-svelte';
import postcss from 'rollup-plugin-postcss';
import resolve from '@rollup/plugin-node-resolve';

export default {
  input: 'src/lib/embed.js',
  output: {
    format: 'iife',
    file: '.dist/embed-rollup.js',
    sourcemap: false,
    name: 'MyBundle',
  },
  plugins: [
    svelte({ emitCss: false }),
    postcss({
      extract: 'global.css',
      minimize: false,
    }),
    resolve({ browser: true, dedupe: ['svelte'] }),
  ],
};
