const exampleData = `
{
    "RightDirectory": "D:/Tmp/phares/VisualStudioCode",
    "Helper": "Day-Helper-2025-05-19",
    "LeftDirectory": "D:/Tmp/phares/VisualStudioCodeLeft",
    "IncludePatternsFile": "z-include-patterns.nsv",
    "ExcludePatternsFile": "z-exclude-patterns.nsv",
    "BaseAddresses": [
        "http://localhost:5004"
    ],
    "Page": "/api/SyncV1/?",
    "LessThan": ",L",
    "GreaterThan": ".G",
    "Segments": [
        "+",
        "G",
        "",
        "L",
        "+",
        "Custom-Default"
    ],
    "Empty": "",
    "Mirror": "+~G~~G~-~Mirror",
    "Update": "+~G~~~~Update",
    "Custom-Default": "+~G~~L~+~Custom-Default",
    "Custom-A": "-~G~~G~+~Custom-A",
    "Custom-B": "-~L~~L~+~Custom-B",
    "Custom-C": "+~L~~L~-~Custom-C"
}
`;

window.addEventListener('message', event => { onDidReceiveMessage(event); });

function onDidReceiveMessage(event) {
  const message = event.data;
  console.info(message);
  const headerGrid = document.getElementById('HeaderGrid');
  const allTextarea = document.getElementById('AllTextarea');
  if (!headerGrid || !allTextarea) {
    console.warn('Could not select html element(s)!');
  }
  else {
    allTextarea.value = '';
    headerGrid.innerHTML = '';
    if (message.command && message.command === 'post') {
      post(allTextarea, headerGrid, event.data);
    }
  }
}

function post(allTextarea, headerGrid, data) {
  $.post(data.input.BaseAddresses[0] + data.input.Page, data.relativePath)
    .done(function (reply) {
      loadPage(allTextarea, headerGrid, data.input, data.relativePath, reply);
    })
    .fail(function (_, textStatus, __) {
      console.warn(textStatus);
    });
}

function loadPage(allTextarea, headerGrid, input, relativePath, reply) {
  console.log('Input value of ' + input);
  console.log('RelativePath value of ' + relativePath);
  console.log('Posted value of ' + reply);
  if (!reply || !reply.RightSideIsNewer) {
    console.warn('Data retrieved is not valid!');
  }
  else {
    let record;
    let line = '';
    let text = 'RelativePath\tSize\tTicks\r\n';
    let html = '<tr><th>RelativePath</th><th>Size</th><th>Ticks</th></tr>';
    for (let i = 0; i < reply.RightSideIsNewer.length; i++) {
      record = reply.RightSideIsNewer[i];
      text += record.Left.RelativePath + '\t' +
        record.Left.Size + '\t' +
        record.Left.Ticks + '\r\n';
      line = '<tr id="tr' + record.Left.Ticks + '-' + record.Left.Size + '"><td>' +
        record.Left.RelativePath + '</td><td>' +
        record.Left.Size + "</td><td>" +
        record.Left.Ticks +
        '</td></tr>';
      html += line;
    }
    headerGrid.innerHTML = html.replaceAll('>null<', '>&nbsp;<');
    allTextarea.value = text.replaceAll('null', '').replaceAll('&nbsp;', '');
  }
}

function getRelativePathAndPost() {
  if (!acquiredVsCodeApi || typeof acquiredVsCodeApi.postMessage !== 'function') {
    console.warn('VSCode function is not available!');
  }
  else {
    acquiredVsCodeApi.postMessage({ command: 'File-Folder-Helper.exe', subcommand: 'post', value: null, collection: [] });
  }
}

if (!exampleData) {
  getRelativePathAndPost();
}