import * as vscode from 'vscode';
import { paramCase } from './promiseLinesHelper';

async function newMarkdownFileLogic(): Promise<any> {
    console.log(vscode.window.tabGroups.activeTabGroup.activeTab?.label);
    if (vscode.workspace.workspaceFolders === undefined) {
        vscode.window.showInformationMessage("Open workspace first!");
        return;
    }
    const workspaceFoldersZero = vscode.workspace.workspaceFolders[0].uri;
    const cardTitle = await vscode.window.showInputBox({ prompt: 'Provide title for card.' });
    if (cardTitle === undefined)
        return;
    const paramCaseCardTitle: string = paramCase(cardTitle);
    const fileUri: vscode.Uri = vscode.Uri.joinPath(workspaceFoldersZero, `${paramCaseCardTitle}.md`);
    const buffer: Buffer = Buffer.from(`# ${cardTitle}`, 'utf8');
    await vscode.workspace.fs.writeFile(fileUri, buffer);
    const textDocument: vscode.TextDocument = await vscode.workspace.openTextDocument(fileUri);
    vscode.window.showTextDocument(textDocument);
}

export const newMarkdownFile = () => newMarkdownFileLogic();
