import * as vscode from 'vscode';

async function rotateExplorerSortOrderLogic(): Promise<any> {
    const config = vscode.workspace.getConfiguration("explorer");
    const sortOrder = config.get("sortOrder");
    let sortOrderOptions = [
        "default",
        "modified",
        "type",
        "mixed",
        "filesFirst",
        "foldersNestsFiles",
    ];
    let index = sortOrderOptions.findIndex(l => l === sortOrder);
    if (index !== -1)
        index++;
    else
        index = 0;
    if (index >= sortOrderOptions.length)
        index = 0;
    let value = sortOrderOptions[index];
    await config.update("sortOrder", value);
    index++;    
    if (index >= sortOrderOptions.length)
        index = 0;
    vscode.window.showInformationMessage(`Explorer Sort Order set to: ${value}; next will be: ${sortOrderOptions[index]};`);
}

export const rotateExplorerSortOrder = () => rotateExplorerSortOrderLogic();